!/bin/sh
#####################################################
# This script was written by inCIDenT@CyberDuDe.CoM #
# V1.00                                             #
#####################################################
clear
echo "[-----------------------------------------------]"
echo "[       Glftpd Installation script V1.00        ]"
echo "[       --------------------------------        ]"
echo "[                                               ]"
echo "[                        -inCIDenT@CyberDuDe.CoM]"
echo "[-----------------------------------------------]"
echo 
echo -n "     Doing Sanity Checks..."
if [ ! "$USER" = "root" ]; then
echo "You must be root to install Glftpd!"
exit 0
fi
if test ! -r `pwd`/bin/glftpd; then
echo "Cannot find source directory!"
exit 0
fi
echo "done" 
echo -n " Where would you like to install Glftpd to ? "
read glftpdir
echo " [x] Installing GlFTPD on "`uname`
echo " [x] Source Directory: "`pwd`
echo " [x] Installation. Directory: $glftpdir"
echo
echo "[- - - -                               - - - - -]"
echo "[      Press return to start the Install        ]"
echo "[- - - -                               - - - - -]"
sourcedir=`pwd`
read null
echo -n "Making Directory..."
mkdir -p $glftpdir
echo "done"
echo -n "Moving package to Directory..."
mv * $glftpdir
echo "done"
echo -n "Checking Binaries..."
cp /sbin/ldconfig /glftpd/bin
bindir="$glftpdir/bin"
cp `which sh` $bindir
cp `which kill` $bindir
cp `which cat` $bindir
cp `which echo` $bindir
cp `which grep` $bindir
echo "done"
if [ "`uname`" = "Linux" ]; then
echo -n "Making Psuedo Devices..."
cd $glftpdir/dev
mknod  $glftpdir/dev/null c 1 3
mknod  $glftpdir/zero c 1 5
chmod 666 $glftpdir/null
chmod 666 $glftpdir/zero
echo "done"
echo -n "Configuring dependencies..."
cp /lib/* $glftpdir/lib > /dev/null
chroot $glftpdir /bin/ldconfig > /dev/null
echo "done"
fi
cp $glftpdir/glftpd.conf /etc/glftpd.conf
echo -n "Configuring inetd.conf..."
echo "glftpd	stream	tcp	nowait	root	/usr/sbin/tcpd	$glftpdir/bin/glftpd -l -o -i" >> /etc/inetd.conf
echo "done"
echo -n "Checking Security..."
echo "glftpd: ALL" >> /etc/hosts.allow
echo "done"
echo
echo "[- -                                          ]"
echo "[ What port would you like GlFTPD to run on ? ]"
echo "[                                          - -]"
echo -n "Port: "
read port
echo -n "Configuring Services..."
echo "glftpd	$port/tcp" >> /etc/services
echo done
echo -n "Restarting Inetd..."
killall -HUP inetd
echo "done"
echo -n "Cleaning Up..."
cd
rm -rf $sourcedir
echo "done"
echo -n "Testing Installation..."
status=`netstat -na | grep $port`
if test -z "$status"; then
echo "ERROR! The Daemon isnt running - Visit #glftpd@EFnet"
exit 0
fi 
echo done
clear
echo
echo
echo "[-----------------------------------------------]"
echo "[       Glftpd Installation script V1.00        ]"
echo "[       --------------------------------        ]"
echo "[                                               ]"
echo "[     Glftpd has been sucessfully installed.    ]"
echo "[      Please refer to the manual for help      ]"
echo "[                                               ]"
echo "[  You will now be presented with a editor to   ]"
echo "[    configure Glftpd's configuration file.     ]"
echo "[                                               ]"
echo "[   For more information about Glftpd, visit    ]"
echo "[  http://glftpd.deepwell.com or #glftpd@EFnet  ]"
echo "[                                               ]" 
echo "[                        -inCIDenT@CyberDuDe.CoM]"
echo "[-----------------------------------------------]"
echo 
echo "[- - - -                               - - - - -]"
echo "[       Press return to start the editor        ]"
echo "[- - - -                               - - - - -]"
read null
if [ "`uname`" = "Linux" ]; then
`which pico` /etc/glftpd.conf
cd
exit 0
fi
if [ "`uname`" = "FreeBSD" ]; then
`which ee` /etc/glftpd.conf
cd
exit 0
fi
`which vi` /etc/glftpd.conf
cd